module Authorize
	extend ActiveSupport::Concern

    	protected 

		def open_for_admin
			if current_user.is_admin?
				"Authorized"
			else
				render "public/404" , layout: "back_end"
			end
		end

		def open_for_manager
			if ((@module_authorized_users.include?(current_user.id) && current_user.is_manager?(@module_app)) || current_user.is_admin?)
				"Authorized"
			else
				render "public/404" , layout: "back_end"
			end
		end

		def open_for_user
			if current_user.present?
				"Authorized"
			else
				render "public/404" , layout: "back_end"
			end
		end

		private

		def set_variables(module_app)
			@module_app = ModuleApp.find_by(key: module_app)
			@categories = @module_app.categories
			@module_authorized_users = Authorization.module_authorized_users(@module_app).pluck(:user_id) rescue nil
		end
end