class SessionsController < ApplicationController
  layout "authentication"
  
  def new
    if session[:user_id]
      redirect_to admin_dashboards_path
    end
  end

  def create
    user = User.find_by(user_name: params[:user_name]) rescue nil
    if (user && user.authenticate(params[:password]) && user.is_confirmed?.eql?(true))
      # if user.is_approved? || user.is_admin?
        session[:user_id] = user.id
        session[:login_referer] = nil
        if params[:referer_url]
          redirect_to URI.parse(params[:referer_url]).path
        else
          redirect_to admin_dashboards_path
        end
      # else
      #   flash.now.alert = "User not approved."
      #   render "new"
      # end
    else
      flash.now.alert = "Invalid username or password"
      render "new"
    end
  end

  def google_result
    @code = params[:code]
    if @code.nil?
      redirect_to root_url
    end
  end

  def google_callback
    error = params[:error] rescue nil
    if error == "access_denied"
      redirect_to auth_failure_path and return
    end
    auth = env["omniauth.auth"]
    user = Google.find_by("google_uid" => auth.uid).user rescue nil
    if user.nil? && current_user.nil?
      user_connected = false
    else
      user_connected = true
       if user.nil? && !current_user.nil?
        connection_successful = connect_account(auth)
      else
        if login_user(user,auth)
          if params[:referer_url]
            redirect_to URI.parse(params[:referer_url]).path and return
          else
            redirect_to admin_dashboards_path and return
          end
        end
      end
    end
    if user_connected && connection_successful
      code = 1
    elsif user_connected && !connection_successful
      code = 2
    else !user_connected && !connection_successful
      code = 3
    end
    redirect_to auth_google_result_path(:code => code)
  end

  def google_remove
    current_user.google.destroy rescue ""
    redirect_to admin_member_path(current_user.member_profile.to_param) and return
  end

  def google_faliure
     @code = 2
     render "google_result"
  end

  def connect_account(auth)
    if !current_user.nil?
      google = Google.new
      google.google_uid = auth.uid
      google.token = auth.credentials.token
      google.connected = true
      google.save
      current_user.google = google
      current_user.save
      return true
    else
      return false
    end
  end

  def login_user(user,auth)
    if user.google.token != auth.credentials.token
      user.google.token = auth.credentials.token
      user.google.save
    end
    session[:user_id] = user.id
  end

  def destroy
    log_user_action
    session[:user_id] = nil
    redirect_to root_url
  end
end
