module AdminHelper
  
  # Check if the current_user is manager in current module app
  def is_manager?
    (@current_user.is_manager?(@module_app) rescue nil) || is_admin?
  end

  # Check if the current_user is sub manager in current module app
  def is_sub_manager?
    (@current_user.is_sub_manager?(@module_app) rescue nil) || is_admin?
  end
  
  def is_admin?
    @current_user.is_admin? rescue false
  end

  def is_member?
    if (@current_user rescue false)
      return true
    end
    return false
  end

  def get_user_module_role(user)
    if user.is_admin?
      t(:admin)
    elsif user.is_manager?(@module_app)
      t(:manager)
    elsif user.is_sub_manager?
      t(:sub_manager)
    end
  end

end