module OrbitCategory
  module Categorizable
    def self.included(base)
      base.extend ClassMethods
      base.field :category_id, type: BSON::ObjectId
    end

    module ClassMethods
       def filter_by_categories(categories=[])
          categories = OrbitHelper.page_categories if categories.blank?
          if !categories.blank?
            if categories.first == "all"
              if OrbitHelper.page_data_count == 0
                self.all
              else
                self.all.page(OrbitHelper.page_number).per(OrbitHelper.page_data_count)
              end
            else
               if OrbitHelper.page_data_count == 0
                self.where(:category_id.in => categories) rescue []
              else
                self.where(:category_id.in => categories).page(OrbitHelper.page_number).per(OrbitHelper.page_data_count) rescue []
              end
            end
          else
            []
          end
      end

       def filter_by_widget_categories(categories=[])
          categories = OrbitHelper.widget_categories if categories.blank?
          if !categories.blank?
            if categories.first == "all"
              if OrbitHelper.widget_data_count == 0
                self.all
              else
                self.all.limit(OrbitHelper.widget_data_count)
              end
            else
               if OrbitHelper.widget_data_count == 0
                self.where(:category_id.in => categories) rescue []
              else
                self.where(:category_id.in => categories).limit(OrbitHelper.widget_data_count) rescue []
              end
            end
          else
            []
          end
      end

       def with_categories(categories=[])
        if categories.blank?
          self.all
        else
          self.where(:category_id.in => categories)
        end
      end
    end

    def category
      Category.find(self.category_id) rescue nil
    end

    def category=(cate)
      self.category_id = Category.find(cate.id).id rescue nil
    end

    def disable?
      Category.find(self.category_id).disable? rescue nil
    end
   
  end
end